## ros-one-cras-cpp-common 2.5.1-41jammy.20251023.0824

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10.2)
project(cras_cpp_common)

set(CMAKE_CXX_STANDARD 17)  # allows better Eigen alignment handling

find_package(catkin REQUIRED COMPONENTS
  bondcpp
  class_loader
  diagnostic_msgs
  diagnostic_updater
  dynamic_reconfigure
  filters
  geometry_msgs
  nodelet
  pluginlib
  rosconsole
  roscpp
  rosgraph_msgs
  sensor_msgs
  std_msgs
  tf2
  tf2_eigen
  tf2_geometry_msgs
  tf2_ros
  tf2_sensor_msgs
  topic_tools
)

# find pthread and provide it as Threads::Threads imported target
set(THREADS_PREFER_PTHREAD_FLAG ON)
find_package(Threads REQUIRED)

find_package(Boost REQUIRED COMPONENTS thread)

find_package(Eigen3 REQUIRED)

find_package(urdfdom_headers REQUIRED)

# Require https://github.com/ros/filters/pull/60 in the filters package (added in 1.8.3 and 1.9.2)
#catkin_lint: ignore_once duplicate_find
find_package(filters QUIET)
if(filters_VERSION VERSION_LESS 1.9.0)
  if(filters_VERSION VERSION_LESS 1.8.3)
    message(FATAL_ERROR "Please update package 'filters' to version 1.8.3 or newer.")
  endif()
else()
  if(filters_VERSION VERSION_LESS 1.9.2)
    message(FATAL_ERROR "Please update package 'filters' to version 1.9.2 or newer.")
  endif()
endif()

find_package(xmlrpcpp QUIET)
if(xmlrpcpp_FOUND AND xmlrpcpp_VERSION VERSION_GREATER_EQUAL 1.17.0)
  set(XMLRPCPP_HAS_PRINTTO 1)
else()
  set(XMLRPCPP_HAS_PRINTTO 0)
endif()
add_compile_options(-DXMLRPCPP_HAS_PRINTTO=${XMLRPCPP_HAS_PRINTTO})

find_package(gencpp QUIET)
if(gencpp_FOUND AND gencpp_VERSION VERSION_GREATER_EQUAL 0.7.2)
  set(GENCPP_HAS_ARRAY_PRINTERS 1)
else()
  set(GENCPP_HAS_ARRAY_PRINTERS 0)
endif()
add_compile_options(-DGENCPP_HAS_ARRAY_PRINTERS=${GENCPP_HAS_ARRAY_PRINTERS})

generate_dynamic_reconfigure_options(
  cfg/FilterChain.cfg
)

catkin_package(
  INCLUDE_DIRS
    include
  CATKIN_DEPENDS
    bondcpp
    class_loader
    diagnostic_msgs
    diagnostic_updater
    dynamic_reconfigure
    filters
    geometry_msgs
    nodelet
    pluginlib
    rosconsole
    roscpp
    sensor_msgs
    tf2
    tf2_ros
    topic_tools
  DEPENDS
    Boost
    EIGEN3
    urdfdom_headers
  LIBRARIES
    cras_c_api
    cras_cloud
    cras_diag_updater
    cras_diag_utils
    cras_log_utils
    cras_node_utils
    cras_nodelet_manager
    cras_nodelet_manager_sharing_tf_buffer
    cras_nodelet_utils
    cras_param_utils
    cras_rate_limiter
    cras_resettable
    cras_semaphore
    cras_string_utils
    cras_tf2_sensor_msgs
    cras_tf2_utils
    cras_thread_utils
    cras_time_utils
    cras_type_utils
    cras_urdf_utils
  CFG_EXTRAS
    ${PROJECT_NAME}-extras.cmake
    ${PROJECT_NAME}-node_from_nodelet.cmake
)

include_directories(
  include
  ${catkin_INCLUDE_DIRS}
)

set(CMAKE_TRY_COMPILE_TARGET_TYPE STATIC_LIBRARY)
try_compile(HAS_FROM_CHARS_FLOAT
  ${CMAKE_BINARY_DIR}/from_chars ${CMAKE_CURRENT_SOURCE_DIR}/cmake/from_chars_try_compile.cpp
  CXX_STANDARD 17)
try_compile(HAS_DESIGNATED_INITIALIZERS
  ${CMAKE_BINARY_DIR}/designated_initializers ${CMAKE_CURRENT_SOURCE_DIR}/cmake/designated_initializers_try_compile.cpp
  CXX_STANDARD 17)

set(CCC_INCLUDE_BASE "${CMAKE_CURRENT_SOURCE_DIR}/include/${PROJECT_NAME}")

add_library(cras_any INTERFACE)
target_sources(cras_any INTERFACE $<BUILD_INTERFACE:${CCC_INCLUDE_BASE}/any.hpp>)
target_sources(cras_any INTERFACE $<BUILD_INTERFACE:${CCC_INCLUDE_BASE}/external/any-lite/any.hpp>)

add_library(cras_expected INTERFACE)
target_sources(cras_expected INTERFACE $<BUILD_INTERFACE:${CCC_INCLUDE_BASE}/expected.hpp>)
target_sources(cras_expected INTERFACE $<BUILD_INTERFACE:${CCC_INCLUDE_BASE}/external/tl/expected.hpp>)

add_library(cras_functional INTERFACE)
target_sources(cras_functional INTERFACE $<BUILD_INTERFACE:${CCC_INCLUDE_BASE}/functional.hpp>)
target_sources(cras_functional INTERFACE $<BUILD_INTERFACE:${CCC_INCLUDE_BASE}/external/invoke.hpp/invoke.hpp>)

add_library(cras_optional INTERFACE)
target_sources(cras_optional INTERFACE $<BUILD_INTERFACE:${CCC_INCLUDE_BASE}/optional.hpp>)
target_sources(cras_optional INTERFACE $<BUILD_INTERFACE:${CCC_INCLUDE_BASE}/external/tl/optional.hpp>)

add_library(cras_span INTERFACE)
target_sources(cras_span INTERFACE $<BUILD_INTERFACE:${CCC_INCLUDE_BASE}/span.hpp>)
target_sources(cras_span INTERFACE $<BUILD_INTERFACE:${CCC_INCLUDE_BASE}/external/tcb/span.hpp>)

add_library(cras_small_map INTERFACE)
target_sources(cras_small_map INTERFACE $<BUILD_INTERFACE:${CCC_INCLUDE_BASE}/small_map.hpp>)

add_library(cras_c_api src/c_api.cpp)

add_library(cras_semaphore src/thread_utils/semaphore.cpp)

add_library(cras_set_utils INTERFACE)
target_sources(cras_set_utils INTERFACE $<BUILD_INTERFACE:${CCC_INCLUDE_BASE}/set_utils.hpp>)

add_library(cras_type_traits INTERFACE)
target_sources(cras_type_traits INTERFACE $<BUILD_INTERFACE:${CCC_INCLUDE_BASE}/type_utils/string_traits.hpp>)

add_library(cras_literal_sz INTERFACE)
target_sources(cras_type_traits INTERFACE $<BUILD_INTERFACE:${CCC_INCLUDE_BASE}/type_utils/literal_sz.h>)

add_library(cras_urdf_utils src/urdf_utils.cpp)
#catkin_lint: ignore_once external_interface_path
target_include_directories(cras_urdf_utils PUBLIC ${urdfdom_headers_INCLUDE_DIRS})
target_link_libraries(cras_urdf_utils
  PUBLIC Eigen3::Eigen)

add_library(cras_pool_allocator INTERFACE)
target_sources(cras_pool_allocator INTERFACE $<BUILD_INTERFACE:${CCC_INCLUDE_BASE}/pool_allocator.hpp>)
target_link_libraries(cras_pool_allocator
  INTERFACE Boost::boost)

add_library(cras_message_utils INTERFACE)
target_sources(cras_message_utils INTERFACE $<BUILD_INTERFACE:${CCC_INCLUDE_BASE}/message_utils.hpp>)
target_link_libraries(cras_message_utils
  INTERFACE ${catkin_LIBRARIES})
add_dependencies(cras_message_utils INTERFACE ${catkin_EXPORTED_TARGETS})

add_library(cras_cloud src/cloud.cpp)
add_dependencies(cras_cloud ${catkin_EXPORTED_TARGETS})
target_link_libraries(cras_cloud
  PUBLIC ${catkin_LIBRARIES})

add_library(cras_diag_updater src/diag_utils/updater.cpp)
add_dependencies(cras_diag_updater ${catkin_EXPORTED_TARGETS})
target_link_libraries(cras_diag_updater
  PUBLIC ${catkin_LIBRARIES})

add_library(cras_nodelet_manager
  src/nodelet_utils/loader_ros.cpp
  src/nodelet_utils/nodelet_manager.cpp)
add_dependencies(cras_nodelet_manager ${catkin_EXPORTED_TARGETS})
target_link_libraries(cras_nodelet_manager
  PUBLIC ${catkin_LIBRARIES} Boost::boost Boost::thread)

add_library(cras_math_utils INTERFACE)
target_sources(cras_math_utils INTERFACE $<BUILD_INTERFACE:${CCC_INCLUDE_BASE}/math_utils.hpp>)
target_sources(cras_math_utils INTERFACE $<BUILD_INTERFACE:${CCC_INCLUDE_BASE}/math_utils/running_stats.hpp>)
target_sources(cras_math_utils INTERFACE $<BUILD_INTERFACE:${CCC_INCLUDE_BASE}/math_utils/running_stats_duration.hpp>)
target_link_libraries(cras_math_utils
  INTERFACE ${catkin_LIBRARIES})

add_library(cras_time_utils
  src/time_utils.cpp
  src/time_utils/interruptible_sleep_interface.cpp)
target_link_libraries(cras_time_utils
  PUBLIC ${catkin_LIBRARIES}
  PRIVATE cras_semaphore Boost::boost)

add_library(cras_rate_limiter src/rate_limiter.cpp)
target_link_libraries(cras_rate_limiter
  PUBLIC ${catkin_LIBRARIES}
  PRIVATE cras_time_utils)

add_library(cras_tf2_utils
  src/tf2_utils.cpp
  src/tf2_utils/interruptible_buffer.cpp)
target_sources(cras_tf2_utils INTERFACE $<BUILD_INTERFACE:${CCC_INCLUDE_BASE}/tf2_utils/message_filter.hpp>)
add_dependencies(cras_tf2_utils ${catkin_EXPORTED_TARGETS})
target_link_libraries(cras_tf2_utils
  PUBLIC cras_log_utils cras_thread_utils cras_time_utils ${catkin_LIBRARIES})

add_library(cras_string_utils src/string_utils.cpp src/string_utils/from_chars.cpp src/string_utils/ros.cpp)
add_dependencies(cras_string_utils ${catkin_EXPORTED_TARGETS})
target_link_libraries(cras_string_utils
  PUBLIC cras_time_utils cras_type_traits ${catkin_LIBRARIES})
if (HAS_FROM_CHARS_FLOAT)
  target_compile_definitions(cras_string_utils PRIVATE HAS_FROM_CHARS_FLOAT=1)
endif()

add_library(cras_thread_utils src/thread_utils.cpp)
target_link_libraries(cras_thread_utils
  PRIVATE cras_string_utils Threads::Threads)

add_library(cras_log_utils src/log_utils.cpp src/log_utils/memory.cpp src/log_utils/node.cpp src/log_utils/nodelet.cpp)
target_link_libraries(cras_log_utils
  PUBLIC cras_string_utils ${catkin_LIBRARIES} PRIVATE cras_time_utils)

# Detect compiler SIMD support. We'll need it for cras_tf2_sensor_msgs target.
include(CheckCXXCompilerFlag)
unset(COMPILER_SUPPORTS_MARCH_X86_V3 CACHE)
unset(COMPILER_SUPPORTS_MARCH_X86_V2 CACHE)
unset(COMPILER_SUPPORTS_MARCH_ARMV8 CACHE)
unset(COMPILER_SUPPORTS_MARCH_ARMV7 CACHE)
unset(COMPILER_SUPPORTS_MARCH_NATIVE CACHE)
set(X86_V2_FLAGS -msse4 -msse3)
set(X86_V3_FLAGS -mavx2 -mavx -mfma)
list(APPEND X86_V3_FLAGS ${X86_V2_FLAGS})
check_cxx_compiler_flag("-march=x86-64 ${X86_V3_FLAGS}" COMPILER_SUPPORTS_MARCH_X86_V3)
check_cxx_compiler_flag("-march=x86-64 ${X86_V2_FLAGS}" COMPILER_SUPPORTS_MARCH_X86_V2)
check_cxx_compiler_flag("-march=armv8-a" COMPILER_SUPPORTS_MARCH_ARMV8)
check_cxx_compiler_flag("-march=armv7-a+neon" COMPILER_SUPPORTS_MARCH_ARMV7)
check_cxx_compiler_flag("-march=native" COMPILER_SUPPORTS_MARCH_NATIVE)

add_library(cras_tf2_sensor_msgs src/tf2_sensor_msgs.cpp)
add_dependencies(cras_tf2_sensor_msgs ${catkin_EXPORTED_TARGETS})
target_link_libraries(cras_tf2_sensor_msgs
  PUBLIC ${catkin_LIBRARIES}
  PRIVATE cras_cloud cras_string_utils Eigen3::Eigen)
# The pointcloud processing loop really needs SIMD. We enable it conservatively.
# ROS buildfarm should pick up x86-64-v3 for x86 builds, armv7 for armhf builds and armv8 for arm64 builds.
if (COMPILER_SUPPORTS_MARCH_X86_V3)
  target_compile_options(cras_tf2_sensor_msgs PRIVATE -march=x86-64 ${X86_V3_FLAGS})
  message("cras_tf2_sensor_msgs uses x86-64-v3 SIMD")
elseif (COMPILER_SUPPORTS_MARCH_X86_V2)
  target_compile_options(cras_tf2_sensor_msgs PRIVATE -march=x86-64 ${X86_V2_FLAGS})
  message("cras_tf2_sensor_msgs uses x86-64-v2 SIMD")
elseif (COMPILER_SUPPORTS_MARCH_ARMV7)
  target_compile_options(cras_tf2_sensor_msgs PRIVATE -march=armv7-a+neon)
  message("cras_tf2_sensor_msgs uses armv7-a+simd SIMD")
elseif (COMPILER_SUPPORTS_MARCH_ARMV8)
  target_compile_options(cras_tf2_sensor_msgs PRIVATE -march=armv8-a)
  message("cras_tf2_sensor_msgs uses armv8-a SIMD")
elseif (COMPILER_SUPPORTS_MARCH_NATIVE)
  target_compile_options(cras_tf2_sensor_msgs PRIVATE -march=native)
  message("cras_tf2_sensor_msgs uses native SIMD")
endif()

add_library(cras_type_utils src/type_utils.cpp)
target_link_libraries(cras_type_utils
  PUBLIC cras_type_traits cras_literal_sz
  PRIVATE cras_string_utils)

add_library(cras_test_utils INTERFACE)
target_sources(cras_test_utils INTERFACE $<BUILD_INTERFACE:${CCC_INCLUDE_BASE}/test_utils/preloading_class_loader.hpp>)
target_link_libraries(cras_test_utils
  INTERFACE cras_type_utils ${catkin_LIBRARIES})

add_library(xmlrpc_value_traits INTERFACE)
target_sources(xmlrpc_value_traits INTERFACE $<BUILD_INTERFACE:${CCC_INCLUDE_BASE}/xmlrpc_value_traits.hpp>)
target_link_libraries(xmlrpc_value_traits
  INTERFACE cras_string_utils ${catkin_LIBRARIES})

add_library(xmlrpc_value_utils INTERFACE)
target_sources(xmlrpc_value_utils INTERFACE $<BUILD_INTERFACE:${CCC_INCLUDE_BASE}/xmlrpc_value_utils.hpp>)
target_link_libraries(xmlrpc_value_utils
  INTERFACE xmlrpc_value_traits)

add_library(cras_param_utils
  src/param_utils/get_param_adapters/node_handle.cpp
  src/param_utils/get_param_adapters/xmlrpc_value.cpp)
target_sources(cras_param_utils INTERFACE $<BUILD_INTERFACE:${CCC_INCLUDE_BASE}/param_utils.hpp>)
add_dependencies(cras_param_utils ${catkin_EXPORTED_TARGETS})
target_link_libraries(cras_param_utils
  PUBLIC cras_log_utils cras_optional cras_string_utils cras_type_utils xmlrpc_value_utils ${catkin_LIBRARIES}
  PRIVATE xmlrpc_value_traits)

add_library(cras_filter_base INTERFACE)
target_sources(cras_filter_base INTERFACE $<BUILD_INTERFACE:${CCC_INCLUDE_BASE}/filter_utils/filter_base.hpp>)
target_link_libraries(cras_filter_base

=== debian/changelog ===
ros-one-cras-cpp-common (2.5.1-41jammy.20251023.0824) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Martin Pecka <peckama2@fel.cvut.cz>  Thu, 23 Oct 2025 08:24:22 +0000

ros-one-cras-cpp-common (2.5.1-0jammy) jammy; urgency=high



 -- Martin Pecka <peckama2@fel.cvut.cz>  Tue, 18 Feb 2025 00:00:00 -0000

ros-one-cras-cpp-common (2.5.0-0jammy) jammy; urgency=high



 -- Martin Pecka <peckama2@fel.cvut.cz>  Thu, 13 Feb 2025 00:00:00 -0000

ros-one-cras-cpp-common (2.4.8-0jammy) jammy; urgency=high

  * Added GetParamConvertingOptions() to ease defining converting getParam() that works with GCC 7.
  * Added NodeWithOptionalMaster.
  * Improved compatibility with newer compilers.
    Resolves https://github.com/RoboStack/ros-noetic/pull/501#issuecomment-2567224502 .
  * Contributors: Martin Pecka

 -- Martin Pecka <peckama2@fel.cvut.cz>  Tue, 07 Jan 2025 00:00:00 -0000

ros-one-cras-cpp-common (2.4.7-0jammy) jammy; urgency=high

  * Fixed installation of nodelet_manager_sharing_tf_buffer.
  * Contributors: Martin Pecka

 -- Martin Pecka <peckama2@fel.cvut.cz>  Thu, 12 Dec 2024 00:00:00 -0000

ros-one-cras-cpp-common (2.4.6-0jammy) jammy; urgency=high

  * nodelet_utils: Allowed accessing the shared_ptr of the shared TF buffer.
  * node_from_nodelet: Worked around the bug where remapping private topics was impossible for anonymous nodes.
  * tf2_utils: Added TfMessageFilter compatible with log_utils.
  * time_utils: Added converters between ros::Time and struct tm.
  * Fixed a few printf format issues.
  * string_utils: Handle possible error in vsnprintf. Added printf-format attributes to cras::format() to enable compile-time checks of format strings.
  * string_utils: Added iconvConvert(), transliterateToAscii() and toValidRosName() functions.
  * Contributors: Martin Pecka

 -- Martin Pecka <peckama2@fel.cvut.cz>  Thu, 12 Dec 2024 00:00:00 -0000

ros-one-cras-cpp-common (2.4.5-0jammy) jammy; urgency=high

  * string_utils: Added date/time parsing methods.
  * string_utils: Added methods for parsing integers with known radix.
  * diag_utils: Added tests for offline diag updater.
  * diag_utils: Added offline diag updater.
  * node_from_nodelet: Added support for stopping the node when requestStop() has been called in the nodelet code.
  * Contributors: Martin Pecka

 -- Martin Pecka <peckama2@fel.cvut.cz>  Sat, 02 Nov 2024 00:00:00 -0000

ros-one-cras-cpp-common (2.4.4-0jammy) jammy; urgency=high

  * Fixed roslint.
  * Contributors: Martin Pecka

 -- Martin Pecka <peckama2@fel.cvut.cz>  Sat, 14 Sep 2024 00:00:00 -0000

ros-one-cras-cpp-common (2.4.3-0jammy) jammy; urgency=high

  * Fixed build with ros_comm 1.17.0 .
  * Contributors: Martin Pecka

 -- Martin Pecka <peckama2@fel.cvut.cz>  Sat, 14 Sep 2024 00:00:00 -0000

ros-one-cras-cpp-common (2.4.2-0jammy) jammy; urgency=high



 -- Martin Pecka <peckama2@fel.cvut.cz>  Thu, 05 Sep 2024 00:00:00 -0000

ros-one-cras-cpp-common (2.4.1-0jammy) jammy; urgency=high

  * Fixed roslint
  * Contributors: Martin Pecka

 -- Martin Pecka <peckama2@fel.cvut.cz>  Wed, 04 Sep 2024 00:00:00 -0000

ros-one-cras-cpp-common (2.4.0-0jammy) jammy; urgency=high

  * Added small_map and fixed concurrency problems in log_utils.
  * Updated fast_float to 6.1.5.
  * node_from_nodelet: Fixed error message
  * Contributors: Martin Pecka

 -- Martin Pecka <peckama2@fel.cvut.cz>  Wed, 04 Sep 2024 00:00:00 -0000

ros-one-cras-cpp-common (2.3.9-0jammy) jammy; urgency=high

  * Removed catkin_lint buildfarm hacks.
  * Updated to fast_float 6.1.0 .
  * Contributors: Martin Pecka

 -- Martin Pecka <peckama2@fel.cvut.cz>  Tue, 27 Feb 2024 00:00:00 -0000

ros-one-cras-cpp-common (2.3.8-0jammy) jammy; urgency=high

  * Fixed FindFilesystem CMake module usage of try_compile
  * Contributors: Martin Pecka

 -- Martin Pecka <peckama2@fel.cvut.cz>  Fri, 12 Jan 2024 00:00:00 -0000

ros-one-cras-cpp-common (2.3.7-0jammy) jammy; urgency=high

  * node_from_nodelet: Fix syntax for Melodic.
  * Contributors: Martin Pecka

 -- Martin Pecka <peckama2@fel.cvut.cz>  Tue, 09 Jan 2024 00:00:00 -0000

ros-one-cras-cpp-common (2.3.6-0jammy) jammy; urgency=high

  * node_from_nodelet: Implemented a simplified version that doesn't need the nodelet header file.
  * node_from_nodelet: Fixed a bug with missing return 0 at the end of main.
  * Contributors: Martin Pecka

 -- Martin Pecka <peckama2@fel.cvut.cz>  Tue, 09 Jan 2024 00:00:00 -0000

ros-one-cras-cpp-common (2.3.5-0jammy) jammy; urgency=high

  * param_utils: Added getParam() specialization for geometry_msgs/Pose messages.
  * nodelet_utils: Added Resettable interface to NodeletWithSharedTfBuffer.
  * Added Resettable interface compatible with cras_py_common.
  * time_utils: Added saturateAdd().
  * Contributors: Martin Pecka

 -- Martin Pecka <peckama2@fel.cvut.cz>  Tue, 21 Nov 2023 00:00:00 -0000

ros-one-cras-cpp-common (2.3.4-0jammy) jammy; urgency=high

  * Do not use -march=native optimizations for cras_tf2_sensor_msgs. More generic platform-specific optimizations are used.
  * Contributors: Martin Pecka

 -- Martin Pecka <peckama2@fel.cvut.cz>  Wed, 25 Oct 2023 00:00:00 -0000

ros-one-cras-cpp-common (2.3.3-0jammy) jammy; urgency=high



 -- Martin Pecka <peckama2@fel.cvut.cz>  Fri, 06 Oct 2023 00:00:00 -0000

ros-one-cras-cpp-common (2.3.2-0jammy) jammy; urgency=high

  * Fix finding std::filesystem in CMake if a non-default launguage standard is used.
  * Contributors: Martin Pecka

 -- Martin Pecka <peckama2@fel.cvut.cz>  Fri, 06 Oct 2023 00:00:00 -0000

ros-one-cras-cpp-common (2.3.1-0jammy) jammy; urgency=high



 -- Martin Pecka <peckama2@fel.cvut.cz>  Thu, 13 Jul 2023 00:00:00 -0000

ros-one-cras-cpp-common (2.3.0-0jammy) jammy; urgency=high

  * Increased minimum CMake version to 3.10.2.
  * log_utils: Fixed a potential segfault when instances of MemoryLogHelper get recycled.
  * Contributors: Martin Pecka

 -- Martin Pecka <peckama2@fel.cvut.cz>  Wed, 12 Jul 2023 00:00:00 -0000



=== debian/control ===
Source: ros-one-cras-cpp-common
Section: misc
Priority: optional
Maintainer: Martin Pecka <peckama2@fel.cvut.cz>
Build-Depends: debhelper (>= 9.0.0), libboost-all-dev, libeigen3-dev, liburdfdom-headers-dev, ros-one-bondcpp, ros-one-catkin, ros-one-class-loader, ros-one-diagnostic-msgs, ros-one-diagnostic-updater, ros-one-dynamic-reconfigure, ros-one-filters, ros-one-gencpp, ros-one-geometry-msgs, ros-one-nodelet, ros-one-pluginlib, ros-one-rosconsole, ros-one-roscpp, ros-one-rosgraph-msgs, ros-one-sensor-msgs, ros-one-std-msgs, ros-one-tf2, ros-one-tf2-eigen, ros-one-tf2-geometry-msgs, ros-one-tf2-ros, ros-one-tf2-sensor-msgs, ros-one-topic-tools
Homepage: https://wiki.ros.org/cras_cpp_common
Standards-Version: 3.9.2

Package: ros-one-cras-cpp-common
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libboost-all-dev, libeigen3-dev, liburdfdom-headers-dev, ros-one-bondcpp, ros-one-class-loader, ros-one-diagnostic-msgs, ros-one-diagnostic-updater, ros-one-dynamic-reconfigure, ros-one-filters, ros-one-geometry-msgs, ros-one-nodelet, ros-one-pluginlib, ros-one-rosconsole, ros-one-roscpp, ros-one-sensor-msgs, ros-one-tf2, ros-one-tf2-ros, ros-one-topic-tools
Description: A Czech-army knife for ROS code written in C++.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/one/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF -DCATKIN_ENABLE_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_configure -- \
		-DFETCHCONTENT_FULLY_DISCONNECTED=OFF \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/one" \
		-DCMAKE_PREFIX_PATH="/opt/ros/one" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-one-cras-cpp-common//opt/ros/one/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_install

## ros-one-cras-cpp-common 2.5.1-41noble.20251023.0828

=== debian/changelog ===
ros-one-cras-cpp-common (2.5.1-41noble.20251023.0828) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Martin Pecka <peckama2@fel.cvut.cz>  Thu, 23 Oct 2025 08:28:29 +0000

ros-one-cras-cpp-common (2.5.1-0noble) noble; urgency=high



 -- Martin Pecka <peckama2@fel.cvut.cz>  Tue, 18 Feb 2025 00:00:00 -0000

ros-one-cras-cpp-common (2.5.0-0noble) noble; urgency=high



 -- Martin Pecka <peckama2@fel.cvut.cz>  Thu, 13 Feb 2025 00:00:00 -0000

ros-one-cras-cpp-common (2.4.8-0noble) noble; urgency=high

  * Added GetParamConvertingOptions() to ease defining converting getParam() that works with GCC 7.
  * Added NodeWithOptionalMaster.
  * Improved compatibility with newer compilers.
    Resolves https://github.com/RoboStack/ros-noetic/pull/501#issuecomment-2567224502 .
  * Contributors: Martin Pecka

 -- Martin Pecka <peckama2@fel.cvut.cz>  Tue, 07 Jan 2025 00:00:00 -0000

ros-one-cras-cpp-common (2.4.7-0noble) noble; urgency=high

  * Fixed installation of nodelet_manager_sharing_tf_buffer.
  * Contributors: Martin Pecka

 -- Martin Pecka <peckama2@fel.cvut.cz>  Thu, 12 Dec 2024 00:00:00 -0000

ros-one-cras-cpp-common (2.4.6-0noble) noble; urgency=high

  * nodelet_utils: Allowed accessing the shared_ptr of the shared TF buffer.
  * node_from_nodelet: Worked around the bug where remapping private topics was impossible for anonymous nodes.
  * tf2_utils: Added TfMessageFilter compatible with log_utils.
  * time_utils: Added converters between ros::Time and struct tm.
  * Fixed a few printf format issues.
  * string_utils: Handle possible error in vsnprintf. Added printf-format attributes to cras::format() to enable compile-time checks of format strings.
  * string_utils: Added iconvConvert(), transliterateToAscii() and toValidRosName() functions.
  * Contributors: Martin Pecka

 -- Martin Pecka <peckama2@fel.cvut.cz>  Thu, 12 Dec 2024 00:00:00 -0000

ros-one-cras-cpp-common (2.4.5-0noble) noble; urgency=high

  * string_utils: Added date/time parsing methods.
  * string_utils: Added methods for parsing integers with known radix.
  * diag_utils: Added tests for offline diag updater.
  * diag_utils: Added offline diag updater.
  * node_from_nodelet: Added support for stopping the node when requestStop() has been called in the nodelet code.
  * Contributors: Martin Pecka

 -- Martin Pecka <peckama2@fel.cvut.cz>  Sat, 02 Nov 2024 00:00:00 -0000

ros-one-cras-cpp-common (2.4.4-0noble) noble; urgency=high

  * Fixed roslint.
  * Contributors: Martin Pecka

 -- Martin Pecka <peckama2@fel.cvut.cz>  Sat, 14 Sep 2024 00:00:00 -0000

ros-one-cras-cpp-common (2.4.3-0noble) noble; urgency=high

  * Fixed build with ros_comm 1.17.0 .
  * Contributors: Martin Pecka

 -- Martin Pecka <peckama2@fel.cvut.cz>  Sat, 14 Sep 2024 00:00:00 -0000

ros-one-cras-cpp-common (2.4.2-0noble) noble; urgency=high



 -- Martin Pecka <peckama2@fel.cvut.cz>  Thu, 05 Sep 2024 00:00:00 -0000

ros-one-cras-cpp-common (2.4.1-0noble) noble; urgency=high

  * Fixed roslint
  * Contributors: Martin Pecka

 -- Martin Pecka <peckama2@fel.cvut.cz>  Wed, 04 Sep 2024 00:00:00 -0000

ros-one-cras-cpp-common (2.4.0-0noble) noble; urgency=high

  * Added small_map and fixed concurrency problems in log_utils.
  * Updated fast_float to 6.1.5.
  * node_from_nodelet: Fixed error message
  * Contributors: Martin Pecka

 -- Martin Pecka <peckama2@fel.cvut.cz>  Wed, 04 Sep 2024 00:00:00 -0000

ros-one-cras-cpp-common (2.3.9-0noble) noble; urgency=high

  * Removed catkin_lint buildfarm hacks.
  * Updated to fast_float 6.1.0 .
  * Contributors: Martin Pecka

 -- Martin Pecka <peckama2@fel.cvut.cz>  Tue, 27 Feb 2024 00:00:00 -0000

ros-one-cras-cpp-common (2.3.8-0noble) noble; urgency=high

  * Fixed FindFilesystem CMake module usage of try_compile
  * Contributors: Martin Pecka

 -- Martin Pecka <peckama2@fel.cvut.cz>  Fri, 12 Jan 2024 00:00:00 -0000

ros-one-cras-cpp-common (2.3.7-0noble) noble; urgency=high

  * node_from_nodelet: Fix syntax for Melodic.
  * Contributors: Martin Pecka

 -- Martin Pecka <peckama2@fel.cvut.cz>  Tue, 09 Jan 2024 00:00:00 -0000

ros-one-cras-cpp-common (2.3.6-0noble) noble; urgency=high

  * node_from_nodelet: Implemented a simplified version that doesn't need the nodelet header file.
  * node_from_nodelet: Fixed a bug with missing return 0 at the end of main.
  * Contributors: Martin Pecka

 -- Martin Pecka <peckama2@fel.cvut.cz>  Tue, 09 Jan 2024 00:00:00 -0000

ros-one-cras-cpp-common (2.3.5-0noble) noble; urgency=high

  * param_utils: Added getParam() specialization for geometry_msgs/Pose messages.
  * nodelet_utils: Added Resettable interface to NodeletWithSharedTfBuffer.
  * Added Resettable interface compatible with cras_py_common.
  * time_utils: Added saturateAdd().
  * Contributors: Martin Pecka

 -- Martin Pecka <peckama2@fel.cvut.cz>  Tue, 21 Nov 2023 00:00:00 -0000

ros-one-cras-cpp-common (2.3.4-0noble) noble; urgency=high

  * Do not use -march=native optimizations for cras_tf2_sensor_msgs. More generic platform-specific optimizations are used.
  * Contributors: Martin Pecka

 -- Martin Pecka <peckama2@fel.cvut.cz>  Wed, 25 Oct 2023 00:00:00 -0000

ros-one-cras-cpp-common (2.3.3-0noble) noble; urgency=high



 -- Martin Pecka <peckama2@fel.cvut.cz>  Fri, 06 Oct 2023 00:00:00 -0000

ros-one-cras-cpp-common (2.3.2-0noble) noble; urgency=high

  * Fix finding std::filesystem in CMake if a non-default launguage standard is used.
  * Contributors: Martin Pecka

 -- Martin Pecka <peckama2@fel.cvut.cz>  Fri, 06 Oct 2023 00:00:00 -0000

ros-one-cras-cpp-common (2.3.1-0noble) noble; urgency=high



 -- Martin Pecka <peckama2@fel.cvut.cz>  Thu, 13 Jul 2023 00:00:00 -0000

ros-one-cras-cpp-common (2.3.0-0noble) noble; urgency=high

  * Increased minimum CMake version to 3.10.2.
  * log_utils: Fixed a potential segfault when instances of MemoryLogHelper get recycled.
  * Contributors: Martin Pecka

 -- Martin Pecka <peckama2@fel.cvut.cz>  Wed, 12 Jul 2023 00:00:00 -0000



## ros-one-cras-cpp-common 2.5.1-89jammy.20251215.2108

=== debian/changelog ===
ros-one-cras-cpp-common (2.5.1-89jammy.20251215.2108) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Martin Pecka <peckama2@fel.cvut.cz>  Mon, 15 Dec 2025 21:08:02 +0000

## ros-one-cras-cpp-common 2.5.1-89noble.20251215.2105

=== debian/changelog ===
ros-one-cras-cpp-common (2.5.1-89noble.20251215.2105) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Martin Pecka <peckama2@fel.cvut.cz>  Mon, 15 Dec 2025 21:05:43 +0000

## ros-one-cras-cpp-common 2.5.1-125jammy.20260119.2100

=== debian/changelog ===
ros-one-cras-cpp-common (2.5.1-125jammy.20260119.2100) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Martin Pecka <peckama2@fel.cvut.cz>  Mon, 19 Jan 2026 21:00:53 +0000

## ros-one-cras-cpp-common 2.5.1-125noble.20260119.2059

=== debian/changelog ===
ros-one-cras-cpp-common (2.5.1-125noble.20260119.2059) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Martin Pecka <peckama2@fel.cvut.cz>  Mon, 19 Jan 2026 20:59:02 +0000

## ros-one-cras-cpp-common 2.5.1-132jammy.20260128.2106

=== debian/changelog ===
ros-one-cras-cpp-common (2.5.1-132jammy.20260128.2106) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Martin Pecka <peckama2@fel.cvut.cz>  Wed, 28 Jan 2026 21:06:02 +0000

## ros-one-cras-cpp-common 2.5.1-132noble.20260128.2106

=== debian/changelog ===
ros-one-cras-cpp-common (2.5.1-132noble.20260128.2106) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Martin Pecka <peckama2@fel.cvut.cz>  Wed, 28 Jan 2026 21:06:59 +0000

## ros-one-cras-cpp-common 2.5.1-140jammy.20260221.0114

=== CMakeLists.txt ===
--- 
+++ 
@@ -153,6 +153,10 @@
 target_sources(cras_span INTERFACE $<BUILD_INTERFACE:${CCC_INCLUDE_BASE}/span.hpp>)
 target_sources(cras_span INTERFACE $<BUILD_INTERFACE:${CCC_INCLUDE_BASE}/external/tcb/span.hpp>)
 
+add_library(cras_tqdm INTERFACE)
+target_sources(cras_tqdm INTERFACE $<BUILD_INTERFACE:${CCC_INCLUDE_BASE}/tqdm.hpp>)
+target_sources(cras_tqdm INTERFACE $<BUILD_INTERFACE:${CCC_INCLUDE_BASE}/external/tqdm/tqdm.hpp>)
+
 add_library(cras_small_map INTERFACE)
 target_sources(cras_small_map INTERFACE $<BUILD_INTERFACE:${CCC_INCLUDE_BASE}/small_map.hpp>)
 
@@ -228,7 +232,7 @@
 target_sources(cras_tf2_utils INTERFACE $<BUILD_INTERFACE:${CCC_INCLUDE_BASE}/tf2_utils/message_filter.hpp>)
 add_dependencies(cras_tf2_utils ${catkin_EXPORTED_TARGETS})
 target_link_libraries(cras_tf2_utils
-  PUBLIC cras_log_utils cras_thread_utils cras_time_utils ${catkin_LIBRARIES})
+  PUBLIC cras_log_utils cras_thread_utils cras_time_utils cras_semaphore ${catkin_LIBRARIES})
 
 add_library(cras_string_utils src/string_utils.cpp src/string_utils/from_chars.cpp src/string_utils/ros.cpp)
 add_dependencies(cras_string_utils ${catkin_EXPORTED_TARGETS})
@@ -315,6 +319,3 @@
   PUBLIC cras_log_utils cras_optional cras_string_utils cras_type_utils xmlrpc_value_utils ${catkin_LIBRARIES}
   PRIVATE xmlrpc_value_traits)
 
-add_library(cras_filter_base INTERFACE)
-target_sources(cras_filter_base INTERFACE $<BUILD_INTERFACE:${CCC_INCLUDE_BASE}/filter_utils/filter_base.hpp>)
-target_link_libraries(cras_filter_base

=== debian/changelog ===
ros-one-cras-cpp-common (2.5.1-140jammy.20260221.0114) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Martin Pecka <peckama2@fel.cvut.cz>  Sat, 21 Feb 2026 01:14:35 +0000

## ros-one-cras-cpp-common 2.5.1-140noble.20260221.0150

=== debian/changelog ===
ros-one-cras-cpp-common (2.5.1-140noble.20260221.0150) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Martin Pecka <peckama2@fel.cvut.cz>  Sat, 21 Feb 2026 01:50:42 +0000
